// zhkuld.cpp : main project file.

#include "stdafx.h"
#include <iostream>


using namespace System;
using namespace std;

class kuldemeny{

	protected:
		int tipus;
		char felado[20],cimzett[20];
 
	public:
    
		/*ures konstruktor*/
		kuldemeny(){cout<<"\nososztaly ures konstruktora";};
    
		/*paramteres konstruktor (inicializalas)*/
		kuldemeny(int tip0, char fel0[20], char cim0[20])
			{tipus=tip0; 
		     strncpy(felado,fel0,20);
		     strncpy(cimzett,cim0,20);
		     cout<<"\nososztaly parameteres konstruktora";};

        /*destruktor*/
	    ~kuldemeny(){};

        /*beolvasas*/
		friend istream& operator>>(istream &is, kuldemeny &m);

		/*kiiras*/
		friend ostream& operator<<(ostream &os, kuldemeny &m);

		/*modositas*/
		void modosit();
		
};

class kuldemeny_ar : public kuldemeny
{
	private:
		int tav, suly;
 
	public:
		
		/*konstruktorok*/
		kuldemeny_ar(){cout<<"\nutodosztaly ures konstruktora";};
		kuldemeny_ar(int tip0, char fel0[20], char cim0[20], int tav0, int suly0):kuldemeny(tip0, fel0, cim0){
			 tav=tav0; suly=suly0;
		     cout<<"\nutod osztaly parameteres konstruktora";};

		/*destruktor*/
		~kuldemeny_ar(){};
		
		/*beolvasas*/
		friend istream& operator>>(istream &is, kuldemeny_ar &m);
		
		/*kiiras*/
		friend ostream& operator<<(ostream &os, kuldemeny_ar &m);

		int ar();
		int operator<(kuldemeny_ar &m);
		
};

/**************************************kuldemeny********************************************/
/*beolvasas*/
    istream& operator>>(istream &is, kuldemeny &m)
    {
		cout<< "felado: ";
		cin >> m.felado;
		cout << "cimzett: ";
		cin >> m.cimzett;
		cout << "tipus: ";
		cin >> m.tipus;
		return is;
    };

/*kiiras*/
    ostream& operator<<(ostream &os, kuldemeny &m)
	{
		cout<<"felado: "<<m.felado<<"  cimzett: "<<m.cimzett<<"  tipus: " << m.tipus; 
		return os;
	};

void kuldemeny::modosit()
{ 
	int valasz=1;
	while (valasz) 
	{
	  cout<<"Mit akar modositani?\n0: semmit\n1: felado \n2: cimzett \n3: tipus\n?";
	  cin>> valasz;
	  switch (valasz)
	  {case 1:cout<<"\nuj felado: "; 
	          cin>> felado;break;
	   case 2:cout<<"\nuj cimzett: "; 
		      cin>> cimzett;break;
	   case 3:cout<<"\nuj tipus: "; 
		      cin>> tipus;
	  }
	}
}

    
/**************************************kuldemeny_ar*************************************/
/*beolvasas*/
 istream& operator>>(istream &is, kuldemeny_ar &m){
		cout<< "felado: ";
		cin >> m.felado;
		cout << "cimzett: ";
		cin >> m.cimzett;
		cout << "tipus: ";
		cin >> m.tipus;
		cout << "tavolsag: ";
		cin >> m.tav;
		cout << "suly: ";
		cin >> m.suly;
		return is;
 };
/*kiiras*/
ostream& operator<<(ostream &os, kuldemeny_ar &m){
		cout << (kuldemeny)m << " tavolsag: " << m.tav<< " suly: " << m.suly; 
		return os;
};

int kuldemeny_ar::ar(){
	int sv=tav*suly;   
	if (tipus) {sv*=2;};
    return sv;
};   

/*kisebb*/
 int kuldemeny_ar::operator<(kuldemeny_ar &m){
	 int kisebb=1;   
	 if ( ar()>=m.ar()) {kisebb=0;};
     return kisebb;
 };   

/***************************************************************************************/
int main(int argc, char *argv[])
{ 
  kuldemeny k1(0,"feladA","cimzA"),k2;
  kuldemeny_ar ka1(1,"feladB","cimzB",100,200),ka2;

  cout << "\n******************\n";
  cout << "SIMA KULDEMENY\n";

  cout << "Kuldemeny:\n "<< k1 << "\n";
  k1.modosit();
  cout << "Modositott kuldemeny:\n "<< k1<< "\n";

  cout << "Masik kuldemeny:\n " ; cin >> k2;
  cout << "Beolvasott kuldemeny:\n "<< k2<< "\n";

  cout << "\n******************\n";
  cout << "KULDEMENY_AR\n";
  cout << "Egyik kuldemeny_ar:\n "<< ka1 << " " << ka1.ar()<<"\n";
  cout << "Masik kuldemeny_ar:\n "; cin >> ka2; 
  cout << "Beolvasott kuldemeny_ar:\n "<< ka2 << " " << ka2.ar()<< "\n";
  if (ka1<ka2) {cout<<"Kisebb az elso\n";} else {cout<<"Nem kisebb az elso\n";};
 
  system("PAUSE");
  return 0;
}
